//\/\/\/\/\/\/\/\/
// User defined values

FlangeDiam=25;
FlangeThickness=5;
NutLength=15;
NutNeckDiam=13;
BoltCircleDiam=19;
BoltSize=3.5;
NumberOfBolts=4;
BoltOffsetAngle=45;

// Choose one...

Mount();	// Generates the full mount
//Test();	// Generates a ring to test the nut's fit

//\/\/\/\/\/\/\/\

FlangeNeckLength=NutLength - FlangeThickness;

$fn=60;


module slot_fill(length = 20) {
	difference() {
		translate([0, 0, 0]) rotate([0, 0, 0])
		 cylinder(r=4.5, h=length, center=true,  $fn=4);	

		//plane sides
		translate([-3.8, 0, 0]) rotate([0, 0, 0])
		 cube([4, 20, length*2], center=true);
		translate([3, 0, 0]) rotate([0, 0, 0])
		 cube([6, 20, length*2], center=true);
	}
}

module Mount()
{
	union()
	{
		difference()
		{
			union()
			{
				difference()
				{
					union()
					{
						hull()
						{
							translate([16.0,  24, 0]) cube([5, 1, 1]);
							translate([16.0, -25, 0]) cube([5, 1, 1]);
							translate([16.0, -17.5, 32.5]) rotate([0, 90, 0]) cylinder(d=15, h=5);
							translate([16.0,  17.5, 32.5]) rotate([0, 90, 0]) cylinder(d=15, h=5);
						}
						
						hull()
						{
							translate([16.0,  24, 0]) cube([5, 1, 10]);
							translate([16.0, -25, 0]) cube([5, 1, 10]);
							translate([0, 11, 0]) cube([5, 1, 10]);
							translate([0, -12, 0]) cube([5, 1, 10]);
						}
						
						hull()
						{
							translate([0, -12.1, 10]) cube([20, 24.2, 2]);
							translate([16, -12.1, 38]) cube([5, 24.2, 2]);
						}
						
						
						translate([20.9, 0, 10]) rotate([90, 0, 180]) slot_fill(49.3);
						translate([20.9, 0, 30]) rotate([90, 0, 180]) slot_fill(49.3);
					}
					
					translate([12, 25, -0.5]) rotate([0, 90, 0]) cylinder(d=5, h=10, $fn=4);
					translate([12, -25, -0.5]) rotate([0, 90, 0]) cylinder(d=5, h=10, $fn=4);

					translate([-5, 12 - 4, -0.5]) rotate([0, 90, 39]) cylinder(d=5, h=30, $fn=4);
					translate([-5, -12 + 4, -0.5]) rotate([0, 90, -39]) cylinder(d=5, h=30, $fn=4);

					hull()
					{
						translate([-5, 18.0, 10.5]) rotate([0, 90, 0]) cylinder(d=12, h=21);
						translate([-5, 18 - 6, 50]) cube([21, 12, 1]);
						translate([-5, 30, 4.5]) cube([21, 1, 1]);
					}

					mirror([0, 1, 0]) hull()
					{
						translate([-5, 18.0, 10.5]) rotate([0, 90, 0]) cylinder(d=12, h=21);
						translate([-5, 18 - 6, 50]) cube([21, 12, 1]);
						translate([-5, 30, 4.5]) cube([21, 1, 1]);
					}

					translate([-1, -5, 10]) cube([17, 10, 50]);
					translate([0, 0, FlangeNeckLength]) cylinder(d=FlangeDiam, h=50);
					
					translate([10,  17.5, 10]) rotate([0, 90, 0]) cylinder(d=5.6, h=15);
					translate([10,  17.5, 30]) rotate([0, 90, 0]) cylinder(d=5.6, h=15);
					translate([10, -17.5, 10]) rotate([0, 90, 0]) cylinder(d=5.6, h=15);
					translate([10, -17.5, 30]) rotate([0, 90, 0]) cylinder(d=5.6, h=15);
				}

				cylinder(d=FlangeDiam, h=FlangeNeckLength);
			}
			
			translate([0, 0, -0.1]) cylinder(d=NutNeckDiam + 0.4, h=FlangeNeckLength + 0.2);
			
		for (z=[0:360/NumberOfBolts:360])
				rotate([0, 0, z + BoltOffsetAngle]) translate([BoltCircleDiam / 2, 0, -0.1])
					cylinder(d=BoltSize, h=FlangeNeckLength + 0.2);
		}
	}
}

module Test()
{
	difference()
	{
		cylinder(d=FlangeDiam, h=FlangeNeckLength);
		
		translate([0, 0, -0.1]) cylinder(d=NutNeckDiam + 0.4, h=FlangeNeckLength + 0.2);
		
		for (z=[0:360/NumberOfBolts:360])
			rotate([0, 0, z + BoltOffsetAngle]) translate([BoltCircleDiam / 2, 0, -0.1]) 
				cylinder(d=BoltSize, h=FlangeNeckLength + 0.2);
	}
}


